print("----")
print("LOSC GIDEROS DEMO")
print("LOSC SERVER")
print("")

local losc = require "losc"
local plugin = require "losc.plugins.udp-socket"
local packet = require "losc.packet"

-- simple server, uses the udp-socket plugin
local udp = plugin.new {
	recvAddr="localhost",
	recvPort=9000,
	ignore_late=true, -- true, false, ignore late bundles
	non_blocking=true, -- true, false, do not block on :open(), :poll() handles processing
}
local osc = losc.new { plugin=udp }

-- a pixel list
local pixels = {}

-- open server
osc:open() -- non blocking call :)
print("server opened")
local isopened = true

-- listeners
local function process_message(msg)
	local pixel = Pixel.new(math.random(0xffff00), 1, 32, 32)
	pixel:setAnchorPoint(0.5, 0.5)
	pixel:setPosition(msg[1] or 0, msg[2] or 0)
	pixels[#pixels+1] = pixel
	stage:addChild(pixel)
end
stage:addEventListener(Event.ENTER_FRAME, function(e)
	local status, data = osc:poll()
	if status and data then
		local message = packet.unpack(data)
		process_message(message)
	end
	for i = #pixels, 1, -1 do
		local pposx, pposy = pixels[i]:getPosition()
		pposy += 2
		pixels[i]:setPosition(pposx, pposy)
		if pposy > 200 then
			stage:removeChild(pixels[i])
			pixels[i] = nil
			table.remove(pixels, i)
		end
	end
end)
stage:addEventListener(Event.KEY_DOWN, function(e)
	isopened = not isopened
	if isopened then
		osc:open() -- non blocking call :)
		print("server opened")
	else
		osc:close()
		print("server closed")
	end
end)
